module Analtex
  class Dictionary
    def initialize
      @word_counts = Hash.new { 0 }
      @word_indices = {}
    end

    def add_word(word)
      @word_counts[word] += 1
    end

    def add_words(words)
      words.each do |word|
        add_word(word)
      end
    end

    def words
      @word_indices
    end

    def word_counts
      @word_counts
    end

    def prepare(min_occurrences = 1)
      raise 'Do not run twice!' unless @word_indices.keys.empty?

      @word_counts.each_pair do |word, occurrences|
        if occurrences >= min_occurrences
          new_word_index = @word_indices.length
          @word_indices[word] = new_word_index
        end
      end
    end
  end
end
